{$apptype console}
// ACM 2009
// Problem C
// (C) Chistyakov T. S.

uses
  SysUtils, Types;
  
var
  n, s: integer;
  p, pSorted: array of TPoint;


var
  fi, fo: textfile;
  i, j, k, k1, k2: integer;
  t: TPoint;
  l, m: integer;
  x: array of integer;
  c: integer;
  bestC, xa, ya, xb, yb: integer;
begin
  assignfile(fi, 'input.txt'); reset(fi);
  assignfile(fo, 'output.txt'); rewrite(fo);

  read(fi, n, s);
  setlength(p, n);
  for i := 0 to n - 1 do
    read(fi, p[i].x, p[i].y);

  pSorted := Copy(p);
  for i := 0 to n - 1 do
    for j := i + 1 to n - 1 do
      if pSorted[i].X > pSorted[j].X then begin
        t := pSorted[i];
        pSorted[i] := pSorted[j];
        pSorted[j] := t;
      end;

  SetLength(x, n);
  bestC := 0;
  xa := 0; ya := 0; xb := 0; yb := 0;  // avoid warnings
  for i := 0 to n - 1 do
    for j := 0 to n - 1 do
      if p[i].Y <= p[j].Y then begin
        if p[i].Y < p[j].Y then
          l := s div (p[j].Y - p[i].Y)
        else
          l := 2 * (pSorted[n - 1].X - pSorted[0].X);
        m := 0;
        for k := 0 to n - 1 do
          if (pSorted[k].Y >= p[i].Y) and (pSorted[k].Y <= p[j].Y) then begin
            x[m] := pSorted[k].X;
            Inc(m);
          end;
        k1 := 0;
        k2 := -1;
        c := 0;
        while k2 < m - 1 do begin
          Inc(k2);
          Inc(c);
          while x[k2] - x[k1] > l do begin
            Inc(k1);
            Dec(c);
          end;
          if c > bestC then begin
            bestC := c;
            xa := x[k1];
            ya := p[i].Y;
            xb := x[k2];
            yb := p[j].Y;
          end;
        end;
      end;

  write(fo, xa, ' ', ya, ' ', xb, ' ', yb);

  closefile(fi);
  closefile(fo);
end.